import { ILifecycleHook } from './lifecycle-hook';
import { Construct } from "../../core";
/**
 * (experimental) Interface for autoscaling lifecycle hook targets.
 *
 * @experimental
 */
export interface ILifecycleHookTarget {
    /**
     * (experimental) Called when this object is used as the target of a lifecycle hook.
     *
     * @experimental
     */
    bind(scope: Construct, lifecycleHook: ILifecycleHook): LifecycleHookTargetConfig;
}
/**
 * (experimental) Properties to add the target to a lifecycle hook.
 *
 * @experimental
 */
export interface LifecycleHookTargetConfig {
    /**
     * (experimental) The ARN to use as the notification target.
     *
     * @experimental
     */
    readonly notificationTargetArn: string;
}
