import * as autoscaling from "../../aws-autoscaling";
import * as cloudwatch from "../../aws-cloudwatch";
import { Construct } from "../../core";
/**
 * (experimental) Use an AutoScaling StepScalingAction as an Alarm Action.
 *
 * @experimental
 */
export declare class AutoScalingAction implements cloudwatch.IAlarmAction {
    private readonly stepScalingAction;
    /**
     * @experimental
     */
    constructor(stepScalingAction: autoscaling.StepScalingAction);
    /**
     * (experimental) Returns an alarm action configuration to use an AutoScaling StepScalingAction as an alarm action.
     *
     * @experimental
     */
    bind(_scope: Construct, _alarm: cloudwatch.IAlarm): cloudwatch.AlarmActionConfig;
}
