import { ConcreteWidget } from './widget';
/**
 * (experimental) Properties for a Text widget.
 *
 * @experimental
 */
export interface TextWidgetProps {
    /**
     * (experimental) The text to display, in MarkDown format.
     *
     * @experimental
     */
    readonly markdown: string;
    /**
     * (experimental) Width of the widget, in a grid of 24 units wide.
     *
     * @default 6
     * @experimental
     */
    readonly width?: number;
    /**
     * (experimental) Height of the widget.
     *
     * @default 2
     * @experimental
     */
    readonly height?: number;
}
/**
 * (experimental) A dashboard widget that displays MarkDown.
 *
 * @experimental
 */
export declare class TextWidget extends ConcreteWidget {
    private readonly markdown;
    /**
     * @experimental
     */
    constructor(props: TextWidgetProps);
    /**
     * (experimental) Place the widget at a given position.
     *
     * @experimental
     */
    position(x: number, y: number): void;
    /**
     * (experimental) Return the widget JSON for use in the dashboard.
     *
     * @experimental
     */
    toJson(): any[];
}
