/**
 * (experimental) The configuration for automatically rolling back deployments in a given Deployment Group.
 *
 * @experimental
 */
export interface AutoRollbackConfig {
    /**
     * (experimental) Whether to automatically roll back a deployment that fails.
     *
     * @default true
     * @experimental
     */
    readonly failedDeployment?: boolean;
    /**
     * (experimental) Whether to automatically roll back a deployment that was manually stopped.
     *
     * @default false
     * @experimental
     */
    readonly stoppedDeployment?: boolean;
    /**
     * (experimental) Whether to automatically roll back a deployment during which one of the configured CloudWatch alarms for this Deployment Group went off.
     *
     * @default true if you've provided any Alarms with the `alarms` property, false otherwise
     * @experimental
     */
    readonly deploymentInAlarm?: boolean;
}
