/**
 * @experimental
 */
export interface Mapping {
    /**
     * (experimental) The user name within Kubernetes to map to the IAM role.
     *
     * @default - By default, the user name is the ARN of the IAM role.
     * @experimental
     */
    readonly username?: string;
    /**
     * (experimental) A list of groups within Kubernetes to which the role is mapped.
     *
     * @see https://kubernetes.io/docs/reference/access-authn-authz/rbac/#default-roles-and-role-bindings
     * @experimental
     */
    readonly groups: string[];
}
