import * as acm from "../../../aws-certificatemanager";
/**
 * (experimental) A certificate source for an ELBv2 listener.
 *
 * @experimental
 */
export interface IListenerCertificate {
    /**
     * (experimental) The ARN of the certificate to use.
     *
     * @experimental
     */
    readonly certificateArn: string;
}
/**
 * (experimental) A certificate source for an ELBv2 listener.
 *
 * @experimental
 */
export declare class ListenerCertificate implements IListenerCertificate {
    /**
     * (experimental) Use an ACM certificate as a listener certificate.
     *
     * @experimental
     */
    static fromCertificateManager(acmCertificate: acm.ICertificate): ListenerCertificate;
    /**
     * (experimental) Use any certificate, identified by its ARN, as a listener certificate.
     *
     * @experimental
     */
    static fromArn(certificateArn: string): ListenerCertificate;
    /**
     * (experimental) The ARN of the certificate to use.
     *
     * @experimental
     */
    readonly certificateArn: string;
    /**
     * @experimental
     */
    protected constructor(certificateArn: string);
}
