import * as lambda from "../../aws-lambda";
import * as sns from "../../aws-sns";
import * as subs from "../../aws-sns-subscriptions";
/**
 * (experimental) Properties forwarded to the Lambda Subscription.
 *
 * @experimental
 */
export interface SnsEventSourceProps extends subs.LambdaSubscriptionProps {
}
/**
 * (experimental) Use an Amazon SNS topic as an event source for AWS Lambda.
 *
 * @experimental
 */
export declare class SnsEventSource implements lambda.IEventSource {
    readonly topic: sns.ITopic;
    private readonly props?;
    /**
     * @experimental
     */
    constructor(topic: sns.ITopic, props?: SnsEventSourceProps);
    /**
     * (experimental) Called by `lambda.addEventSource` to allow the event source to bind to this function.
     *
     * @experimental
     */
    bind(target: lambda.IFunction): void;
}
