import * as lambda from "../../aws-lambda";
import { Construct } from "../../core";
/**
 * (experimental) Properties for PythonLayerVersion.
 *
 * @experimental
 */
export interface PythonLayerVersionProps extends lambda.LayerVersionOptions {
    /**
     * (experimental) The path to the root directory of the lambda layer.
     *
     * @experimental
     */
    readonly entry: string;
    /**
     * (experimental) The runtimes compatible with the python layer.
     *
     * @default - All runtimes are supported.
     * @experimental
     */
    readonly compatibleRuntimes?: lambda.Runtime[];
}
/**
 * (experimental) A lambda layer version.
 *
 * @experimental
 */
export declare class PythonLayerVersion extends lambda.LayerVersion {
    /**
     * @experimental
     */
    constructor(scope: Construct, id: string, props: PythonLayerVersionProps);
}
