import { IEventSourceMapping } from './event-source-mapping';
import { IFunction } from './function-base';
/**
 * (experimental) A destination configuration.
 *
 * @experimental
 */
export interface DlqDestinationConfig {
    /**
     * (experimental) The Amazon Resource Name (ARN) of the destination resource.
     *
     * @experimental
     */
    readonly destination: string;
}
/**
 * (experimental) A DLQ for an event source.
 *
 * @experimental
 */
export interface IEventSourceDlq {
    /**
     * (experimental) Returns the DLQ destination config of the DLQ.
     *
     * @experimental
     */
    bind(target: IEventSourceMapping, targetHandler: IFunction): DlqDestinationConfig;
}
