/**
 * (experimental) Zone properties for looking up the Hosted Zone.
 *
 * @experimental
 */
export interface HostedZoneProviderProps {
    /**
     * (experimental) The zone domain e.g. example.com.
     *
     * @experimental
     */
    readonly domainName: string;
    /**
     * (experimental) Whether the zone that is being looked up is a private hosted zone.
     *
     * @default false
     * @experimental
     */
    readonly privateZone?: boolean;
    /**
     * (experimental) Specifies the ID of the VPC associated with a private hosted zone.
     *
     * If a VPC ID is provided and privateZone is false, no results will be returned
     * and an error will be raised
     *
     * @default - No VPC ID
     * @experimental
     */
    readonly vpcId?: string;
}
