import * as s3 from "../../aws-s3";
import * as sns from "../../aws-sns";
import { Construct } from "../../core";
/**
 * (experimental) Use an SNS topic as a bucket notification destination.
 *
 * @experimental
 */
export declare class SnsDestination implements s3.IBucketNotificationDestination {
    private readonly topic;
    /**
     * @experimental
     */
    constructor(topic: sns.ITopic);
    /**
     * (experimental) Registers this resource to receive notifications for the specified bucket.
     *
     * This method will only be called once for each destination/bucket
     * pair and the result will be cached, so there is no need to implement
     * idempotency in each destination.
     *
     * @experimental
     */
    bind(_scope: Construct, bucket: s3.IBucket): s3.BucketNotificationDestinationConfig;
}
