import * as iam from "../../aws-iam";
import { Resource } from "../../core";
import { Construct } from 'constructs';
import { ISecret } from './secret';
/**
 * (experimental) Construction properties for a ResourcePolicy.
 *
 * @experimental
 */
export interface ResourcePolicyProps {
    /**
     * (experimental) The secret to attach a resource-based permissions policy.
     *
     * @experimental
     */
    readonly secret: ISecret;
}
/**
 * (experimental) Secret Resource Policy.
 *
 * @experimental
 */
export declare class ResourcePolicy extends Resource {
    /**
     * (experimental) The IAM policy document for this policy.
     *
     * @experimental
     */
    readonly document: iam.PolicyDocument;
    /**
     * @experimental
     */
    constructor(scope: Construct, id: string, props: ResourcePolicyProps);
}
