import * as ses from "../../aws-ses";
import * as sns from "../../aws-sns";
/**
 * (experimental) Construction properties for a stop action.
 *
 * @experimental
 */
export interface StopProps {
    /**
     * (experimental) The SNS topic to notify when the stop action is taken.
     *
     * @experimental
     */
    readonly topic?: sns.ITopic;
}
/**
 * (experimental) Terminates the evaluation of the receipt rule set and optionally publishes a notification to Amazon SNS.
 *
 * @experimental
 */
export declare class Stop implements ses.IReceiptRuleAction {
    private readonly props;
    /**
     * @experimental
     */
    constructor(props?: StopProps);
    /**
     * (experimental) Returns the receipt rule action specification.
     *
     * @experimental
     */
    bind(_rule: ses.IReceiptRule): ses.ReceiptRuleActionConfig;
}
