import * as iam from "../../../aws-iam";
import * as sfn from "../../../aws-stepfunctions";
import { Construct } from 'constructs';
/**
 * (experimental) Properties for getting a Query Execution.
 *
 * @experimental
 */
export interface AthenaGetQueryExecutionProps extends sfn.TaskStateBaseProps {
    /**
     * (experimental) Query that will be retrieved.
     *
     * @experimental
     * @example
     *
     * 'adfsaf-23trf23-f23rt23'
     */
    readonly queryExecutionId: string;
}
/**
 * (experimental) Get an Athena Query Execution as a Task.
 *
 * @see https://docs.aws.amazon.com/step-functions/latest/dg/connect-athena.html
 * @experimental
 */
export declare class AthenaGetQueryExecution extends sfn.TaskStateBase {
    private readonly props;
    private static readonly SUPPORTED_INTEGRATION_PATTERNS;
    /**
     * @experimental
     */
    protected readonly taskMetrics?: sfn.TaskMetricsConfig;
    /**
     * @experimental
     */
    protected readonly taskPolicies?: iam.PolicyStatement[];
    private readonly integrationPattern;
    /**
     * @experimental
     */
    constructor(scope: Construct, id: string, props: AthenaGetQueryExecutionProps);
    /**
     * Provides the Athena get query execution service integration task configuration
     * @internal
     */
    protected _renderTask(): any;
}
