/**
 * (experimental) Destination for assets that need to be uploaded to AWS.
 *
 * @experimental
 */
export interface AwsDestination {
    /**
     * (experimental) The region where this asset will need to be published.
     *
     * @default - Current region
     * @experimental
     */
    readonly region?: string;
    /**
     * (experimental) The role that needs to be assumed while publishing this asset.
     *
     * @default - No role will be assumed
     * @experimental
     */
    readonly assumeRoleArn?: string;
    /**
     * (experimental) The ExternalId that needs to be supplied while assuming this role.
     *
     * @default - No ExternalId will be supplied
     * @experimental
     */
    readonly assumeRoleExternalId?: string;
}
