import { DockerImageAsset } from './docker-image-asset';
import { FileAsset } from './file-asset';
/**
 * (experimental) Definitions for the asset manifest.
 *
 * @experimental
 */
export interface AssetManifest {
    /**
     * (experimental) Version of the manifest.
     *
     * @experimental
     */
    readonly version: string;
    /**
     * (experimental) The file assets in this manifest.
     *
     * @default - No files
     * @experimental
     */
    readonly files?: {
        [id: string]: FileAsset;
    };
    /**
     * (experimental) The Docker image assets in this manifest.
     *
     * @default - No Docker images
     * @experimental
     */
    readonly dockerImages?: {
        [id: string]: DockerImageAsset;
    };
}
